#include <stdio.h>

#define NORMAL "\E[22;00m"
#define RED "\E[31;01m"
#define GREEN "\E[32;22m"
#define YELLOW "\E[33;01m"
#define MAGENTA "\E[35;01m"
#define CYAN "\E[36;01m"


#define ERR(fmt, args...) g_printerr(fmt, ## args)
#define DBG2(fmt, args...) g_printerr(RED"%s"GREEN":"CYAN"%s"GREEN":"YELLOW"%-5d"GREEN": "NORMAL fmt, __FILE__,  __FUNCTION__, __LINE__, ## args)
#define ENTER2          do { g_printerr(RED"%s"GREEN":"CYAN"%s"GREEN":"YELLOW"%-5d"GREEN": "MAGENTA"ENTER\n",  __FILE__,__FUNCTION__, __LINE__); } while(0)
#define RET2(args...)   do { g_printerr(RED"%s"GREEN":"CYAN"%s"GREEN":"YELLOW"%-5d"GREEN": "MAGENTA"RETURN\n",  __FILE__,__FUNCTION__, __LINE__);\
return args; } while(0)
enum { LOG_NONE, LOG_ERR, LOG_WARN, LOG_INFO, LOG_ALL };


#if defined DEBUG
#define ENTER          do { g_printerr(RED"%s"GREEN":"CYAN"%s"GREEN":"YELLOW"%-5d"GREEN": "MAGENTA"ENTER\n",  __FILE__,__FUNCTION__, __LINE__); } while(0)
#define RET(args...)   do { g_printerr(RED"%s"GREEN":"CYAN"%s"GREEN":"YELLOW"%-5d"GREEN": "MAGENTA"RETURN\n", __FILE__, __FUNCTION__, __LINE__);\
return args; } while(0)
#define DBG(fmt, args...) g_printerr(RED"%s"GREEN":"CYAN"%s"GREEN":"YELLOW"%-5d"GREEN": "NORMAL fmt,  __FILE__,__FUNCTION__, __LINE__, ## args)
#define LOG(level, fmt, args...) g_printerr(fmt, ## args)

#elif defined VERBOSE
#define ENTER         ;
#define RET(args...)   return args
#define DBG(fmt, args...) g_printerr(RED"%s"GREEN":"CYAN"%s"GREEN":"YELLOW"%-5d"GREEN": "NORMAL fmt,  __FILE__,__FUNCTION__, __LINE__, ## args)
#define LOG(level, fmt, args...) g_printerr(fmt, ## args)

#else
extern int log_level;
#define ENTER         ;
#define RET(args...)   return args
#define DBG(fmt, args...)   ;
#define LOG(level, fmt, args...) do { if (level <= log_level) g_printerr(fmt, ## args); } while(0)
#endif

